/**********************************************************************
 * ֻѧϰʹãδɣκ;
 * ӲƬSTC89C52RC,Ƶ12MHZ
 * ˵ST7775R 3SPI
 
 ----------------------------------------------------
 |ǧһʾƼ޹˾                        |
 |˾վ:www.qytft.com                            |
 |Ավhttps://shop580133616.taobao.com        |
 |̻() :+86 0755-27908130                     |
 |ҵѯ:18823372746 (쾭 WXͬ)              |
 |ҵѯ:15989313508 (뾭 WXͬ)              |
 ----------------------------------------------------

 ----------------------------------------------------
 |˾ṩ֧֣κμ⻶ӭʱѧϰ    |
 |֧QQ:3597321058                             |
 |֧:qyxskj@126.com                       |
 |֧:13723763193ܹ WXͬţ               |
 |QQȺ:792027219                            |
 ----------------------------------------------------

 * ˵:
 ========================ԴŽ==================================        
 |   LCDģ           Ƭ                                     |
 |     VCC      --->      3.3V      //Դ                            |
 |     GND      --->      GND       //Դ                          | 
 |====================ƼŽ==============================|
 |   LCDģ 			     Ƭ                                     |
 |     CS       --->      P13       //ҺƬѡźţ͵ƽЧ|
 |     RST      --->      P33       //Һλźţ͵ƽЧ|
 |     SCL      --->      P17       //ҺSPIʱź           |
 |     SDI      --->      P15       //ҺSPIдź         |
 |     SDO      --->      P16       //ҺSPI߶ź         |
 ======================================================================
 
 * :2020/5/13
 * 汾V1.0
 * ȨУؾ
 * Copyright(C) ǧһʾƼ޹˾ 2020-2035
 * All rights reserved
**********************************************************************/
#include "main.h"

u16 width=LCD_W;
u16 height=LCD_H;
u8 direction=0;
void delay_ms(int count)  // /* X1ms */
{
    int i,j;
	for(i=0;i<count;i++)
        for(j=0;j<1000;j++);
}

void delay_us(int count)  // /* X1us */
{
    int i,j;
        for(i=0;i<count;i++)
            for(j=0;j<1;j++);
}

void SPI_WriteRS(u8 rs)
{
	if(rs)
	{
		LCD_SDI=1;
	}
	else
	{
		LCD_SDI=0;
	}
	LCD_CLK=0;
	LCD_CLK=1;
}

void SPI_WriteByte(u8 byte)
{			
	u8 i=0;
	for(i=0;i<8;i++)
	{
		if(byte&0x80)
		{
			LCD_SDI=1;
		}
		else
		{
			LCD_SDI=0;
		}
		LCD_CLK=0;
		LCD_CLK=1;
		byte<<=1;
	}
}

void LCD_WR_REG(u16 Reg)	 
{	
	LCD_CS=0;
	SPI_WriteRS(0);
	SPI_WriteByte(Reg>>8);
	SPI_WriteRS(0);
	SPI_WriteByte(Reg);
	LCD_CS=1;
} 

void LCD_WR_DATA(u16 Data)
{
	LCD_CS=0;
	SPI_WriteRS(1);
	SPI_WriteByte(Data>>8);
	SPI_WriteRS(1);
	SPI_WriteByte(Data);
	LCD_CS=1;
}

void LCD_WriteReg(u16 LCD_Reg, u16 LCD_RegValue)
{
	LCD_WR_REG(LCD_Reg);
	LCD_WR_DATA(LCD_RegValue);
}

void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
{	
	u16 x,y,tmp;
	switch(direction)
	{
		case 0:
			x = xStar;
			y = yStar;
			break;
		case 1:
			tmp = yStar;
			yStar = xStar;
			xStar = LCD_W-1-yEnd;
			yEnd = xEnd;
			xEnd = LCD_W-1-tmp;
			x = xEnd;
			y = yStar;
			break;
		case 2:
			tmp = xStar;
			xStar = LCD_W-1-xEnd;
			xEnd = LCD_W-1-tmp;
			tmp = yStar;
			yStar = LCD_H-1-yEnd;
			yEnd = LCD_H-1-tmp;
			x = xEnd;
			y = yEnd;
			break;
		case 3:
			tmp = xStar;
			xStar = yStar;
			yStar = LCD_H-1-xEnd;
			xEnd = yEnd;
			yEnd = LCD_H-1-tmp;
			x = xStar;
			y = yEnd;
			break;
		default:
			break;
	}
	LCD_WriteReg(0x0036, xEnd);
	LCD_WriteReg(0x0037, xStar);
	LCD_WriteReg(0x0038, yEnd);
	LCD_WriteReg(0x0039, yStar);
	LCD_WriteReg(SET_X_ADD_CMD, x);
	LCD_WriteReg(SET_Y_ADD_CMD, y);
	LCD_WR_REG(WR_RAM_CMD);	//ʼдGRAM				
}   

void LCD_Clear(u16 Color)
{
	u16 i,j;
	LCD_SetWindows(0,0,width-1,height-1);	
  for(i=0;i<width;i++)
	{
	  for (j=0;j<height;j++)
	  {
			LCD_WR_DATA(Color);
	  }
	}
}

void LCD_Reset(void)
{	
	LCD_RESET=0;
	delay_ms(100);
	LCD_RESET=1;
	delay_ms(50);
}

void LCD_direction(u8 dir)
{ 
	direction=dir%4;
	switch(direction){		  
		case 0:						 	 		
			width=LCD_W;
			height=LCD_H;		
			LCD_WriteReg(0x0003,0x1030);
		break;
		case 1:
			width=LCD_H;
			height=LCD_W;
			LCD_WriteReg(0x0003,0x1028);
		break;
		case 2:						 	 		
			width=LCD_W;
			height=LCD_H;	
			LCD_WriteReg(0x0003,0x1000);
		break;
		case 3:
			width=LCD_H;
			height=LCD_W;
			LCD_WriteReg(0x0003,0x1018);
		break;	
		default:break;
	}		
}

void LCD_Init(void)
{
	LCD_Reset(); //ʼ֮ǰλ
//*************ST7775Rʼ**********//
	LCD_WR_REG(0x0001);
	LCD_WR_DATA(0x011C);
	LCD_WR_REG(0x0002);
	LCD_WR_DATA(0x0100);
	LCD_WR_REG(0x0003);
	LCD_WR_DATA(0x1030);
	LCD_WR_REG(0x0008);
	LCD_WR_DATA(0x0808);
	LCD_WR_REG(0x000C);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x000F);
	LCD_WR_DATA(0x0001);
	LCD_WR_REG(0x0020);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0021);
	LCD_WR_DATA(0x0000);
	//-----------------------------------End Display Control setting-----------------------------------------//
	//-------------------------------- Power Control Registers Initial --------------------------------------//
	LCD_WR_REG(0x0010);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0011);
	LCD_WR_DATA(0x1000);
	//---------------------------------End Power Control Registers Initial -------------------------------//
	delay_ms(100);
	//----------------------------------Display Windows 176 X 220----------------------------------------//
	LCD_WR_REG(0x0030);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0031);
	LCD_WR_DATA(0x00DB);
	LCD_WR_REG(0x0032);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0033);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0034);
	LCD_WR_DATA(0x00DB);
	LCD_WR_REG(0x0035);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0036);
	LCD_WR_DATA(0x00AF);
	LCD_WR_REG(0x0037);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0038);
	LCD_WR_DATA(0x00DB);
	LCD_WR_REG(0x0039);
	LCD_WR_DATA(0x0000);
	//----------------------------------End Display Windows 176 X 220----------------------------------//
	delay_ms(10);
	LCD_WR_REG(0x00ff);
	LCD_WR_DATA(0x0003);
	//-------------------------------------Gamma Cluster Setting-------------------------------------------//
	LCD_WR_REG(0x0050);
	LCD_WR_DATA(0x0203);
	LCD_WR_REG(0x0051);
	LCD_WR_DATA(0x0a09);
	LCD_WR_REG(0x0052);
	LCD_WR_DATA(0x0005);
	LCD_WR_REG(0x0053);
	LCD_WR_DATA(0x1021);
	LCD_WR_REG(0x0054);
	LCD_WR_DATA(0x0602);
	LCD_WR_REG(0x0055);
	LCD_WR_DATA(0x0003);
	LCD_WR_REG(0x0056);
	LCD_WR_DATA(0x0703);
	LCD_WR_REG(0x0057);
	LCD_WR_DATA(0x0507);
	LCD_WR_REG(0x0058);
	LCD_WR_DATA(0x1021);
	LCD_WR_REG(0x0059);
	LCD_WR_DATA(0x0703);
	//---------------------------------------End Gamma Setting---------------------------------------------//
	//--------------------------------------Vcom Setting---------------------------------------------//
	LCD_WR_REG(0x00B0);
	LCD_WR_DATA(0x2301);
	LCD_WR_REG(0x00B1); //Աȶ
	LCD_WR_DATA(0x0000);
	//---------------------------------------End Vcom Setting---------------------------------------------//
	LCD_WR_REG(0x00ff);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0007);
	LCD_WR_DATA(0x1017);
	delay_ms(200); //Delay 200ms	
//	LCD_BL=1;//	 
}

//
void main(void)
{ 
	u8 i=0;
	//Һʼ
	LCD_Init();

	//ѭи	
	while(1)
	{
		LCD_direction(i++);
		LCD_Clear(WHITE);delay_ms(1000);
		LCD_Clear(BLACK);delay_ms(1000);
		LCD_Clear(RED);delay_ms(1000);
		LCD_Clear(GREEN);delay_ms(1000);
		LCD_Clear(BLUE);delay_ms(1000);
		if(i>3)
		{
			i=0;
		}
	}   
}
